Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_lap.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_lap.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRA/traldf_lap.F90	(revision 2528)
@@ -2,6 +2,15 @@
    !!==============================================================================
    !!                       ***  MODULE  traldf_lap  ***
-   !! Ocean active tracers:  horizontal component of the lateral tracer mixing trend
+   !! Ocean  tracers:  horizontal component of the lateral tracer mixing trend
    !!==============================================================================
+   !! History :  OPA  !  87-06  (P. Andrich, D. L Hostis)  Original code
+   !!                 !  91-11  (G. Madec)
+   !!                 !  95-11  (G. Madec)  suppress volumetric scale factors
+   !!                 !  96-01  (G. Madec)  statement function for e3
+   !!            NEMO !  02-06  (G. Madec)  F90: Free form and module
+   !!            1.0  !  04-08  (C. Talandier) New trends organization
+   !!                 !  05-11  (G. Madec)  add zps case
+   !!            3.0  !  10-06  (C. Ethe, G. Madec) Merge TRA-TRC
+   !!----------------------------------------------------------------------
 
    !!----------------------------------------------------------------------
@@ -9,20 +18,17 @@
    !!                 using a iso-level harmonic (laplacien) operator.
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and active tracers
    USE dom_oce         ! ocean space and time domain
    USE ldftra_oce      ! ocean active tracers: lateral physics
-   USE trdmod          ! ocean active tracers trends 
-   USE trdmod_oce      ! ocean variables trends
    USE in_out_manager  ! I/O manager
    USE diaptr          ! poleward transport diagnostics
-   USE prtctl          ! Print control
-
+   USE trc_oce         ! share passive tracers/Ocean variables
 
    IMPLICIT NONE
    PRIVATE
 
-   !! * Routine accessibility
-   PUBLIC tra_ldf_lap  ! routine called by step.F90
+   PUBLIC   tra_ldf_lap   ! routine called by step.F90
+
+   REAL(wp), DIMENSION(jpi,jpj) ::   e1ur, e2vr   ! scale factor coefficients
 
    !! * Substitutions
@@ -31,12 +37,12 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Id$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
-   
 CONTAINS
 
-   SUBROUTINE tra_ldf_lap( kt )
+   SUBROUTINE tra_ldf_lap( kt, cdtype, pgu, pgv,      &
+      &                                ptb, pta, kjpt ) 
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE tra_ldf_lap  ***
@@ -47,134 +53,91 @@
       !! ** Method  :   Second order diffusive operator evaluated using before
       !!      fields (forward time scheme). The horizontal diffusive trends of 
-      !!      temperature (idem for salinity) is given by:
+      !!      the tracer is given by:
       !!          difft = 1/(e1t*e2t*e3t) {  di-1[ aht e2u*e3u/e1u di(tb) ]
       !!                                   + dj-1[ aht e1v*e3v/e2v dj(tb) ] }
-      !!     Note: key_zco defined, the e3t=e3u=e3v, the trend becomes:  
-      !!          difft = 1/(e1t*e2t) {  di-1[ aht e2u/e1u di(tb) ]
-      !!                               + dj-1[ aht e1v/e2v dj(tb) ] }
-      !!      Add this trend to the general tracer trend (ta,sa):
-      !!          (ta,sa) = (ta,sa) + ( difft , diffs )
+      !!      Add this trend to the general tracer trend pta :
+      !!          pta = pta + difft
       !!
-      !! ** Action  : - Update (ta,sa) arrays with the before iso-level 
+      !! ** Action  : - Update pta arrays with the before iso-level 
       !!                harmonic mixing trend.
+      !!----------------------------------------------------------------------
+      USE oce         , ztu => ua   ! use ua as workspace
+      USE oce         , ztv => va   ! use va as workspace
       !!
-      !! History :
-      !!   1.0  !  87-06  (P. Andrich, D. L Hostis)  Original code
-      !!        !  91-11  (G. Madec)
-      !!        !  95-11  (G. Madec)  suppress volumetric scale factors
-      !!        !  96-01  (G. Madec)  statement function for e3
-      !!   8.5  !  02-06  (G. Madec)  F90: Free form and module
-      !!   9.0  !  04-08  (C. Talandier) New trends organization
-      !!        !  05-11  (G. Madec)  add zps case
-      !!----------------------------------------------------------------------
-      USE oce              , ztu => ua,  &  ! use ua as workspace
-         &                   zsu => va      ! use va as workspace
-
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   kt       ! ocean time-step index
-      
-      !! * Local save
-      REAL(wp), DIMENSION(jpi,jpj), SAVE ::   &
-         ze1ur, ze2vr, zbtr2              ! scale factor coefficients
-      
-      !! * Local declarations
-      INTEGER ::   ji, jj, jk             ! dummy loop indices
-      INTEGER ::   iku, ikv               ! temporary integers
-      REAL(wp) ::   &
-         zabe1, zta,                   &  ! temporary scalars
-         zabe2, zsa, zbtr                 !    "         "
-      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   &
-         ztv, zsv                         ! 3D workspace
+      INTEGER                              , INTENT(in   ) ::   kt         ! ocean time-step index
+      CHARACTER(len=3)                     , INTENT(in   ) ::   cdtype     ! =TRA or TRC (tracer indicator)
+      INTEGER                              , INTENT(in   ) ::   kjpt       ! number of tracers
+      REAL(wp), DIMENSION(jpi,jpj    ,kjpt), INTENT(in   ) ::   pgu, pgv   ! tracer gradient at pstep levels
+      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(in   ) ::   ptb        ! before and now tracer fields
+      REAL(wp), DIMENSION(jpi,jpj,jpk,kjpt), INTENT(inout) ::   pta        ! tracer trend 
+      !!
+      INTEGER  ::   ji, jj, jk, jn       ! dummy loop indices
+      INTEGER  ::   iku, ikv             ! local integers
+      REAL(wp) ::   zabe1, zabe2, zbtr   ! local scalars
       !!----------------------------------------------------------------------
       
-      IF( kt == nit000 ) THEN
+      IF( kt == nit000 )  THEN
          IF(lwp) WRITE(numout,*)
-         IF(lwp) WRITE(numout,*) 'tra_ldf_lap : iso-level laplacian diffusion'
+         IF(lwp) WRITE(numout,*) 'tra_ldf_lap : iso-level laplacian diffusion on ', cdtype
          IF(lwp) WRITE(numout,*) '~~~~~~~~~~~ '
-         ze1ur(:,:) = e2u(:,:) / e1u(:,:)
-         ze2vr(:,:) = e1v(:,:) / e2v(:,:)
-         zbtr2(:,:) = 1. / ( e1t(:,:) * e2t(:,:) )
+         e1ur(:,:) = e2u(:,:) / e1u(:,:)
+         e2vr(:,:) = e1v(:,:) / e2v(:,:)
       ENDIF
-      
-      !                                                  ! =============
-      DO jk = 1, jpkm1                                   ! Vertical slab
-         !                                               ! =============
-         ! 1. First derivative (gradient)
-         ! -------------------
-         DO jj = 1, jpjm1
-            DO ji = 1, fs_jpim1   ! vector opt.
-#if defined key_zco
-               zabe1 = fsahtu(ji,jj,jk) * umask(ji,jj,jk) * ze1ur(ji,jj)
-               zabe2 = fsahtv(ji,jj,jk) * vmask(ji,jj,jk) * ze2vr(ji,jj)
-#else
-               zabe1 = fsahtu(ji,jj,jk) * umask(ji,jj,jk) * ze1ur(ji,jj) * fse3u(ji,jj,jk)
-               zabe2 = fsahtv(ji,jj,jk) * vmask(ji,jj,jk) * ze2vr(ji,jj) * fse3v(ji,jj,jk)
-#endif
-               ztu(ji,jj,jk) = zabe1 * ( tb(ji+1,jj  ,jk) - tb(ji,jj,jk) )
-               zsu(ji,jj,jk) = zabe1 * ( sb(ji+1,jj  ,jk) - sb(ji,jj,jk) )
-               ztv(ji,jj,jk) = zabe2 * ( tb(ji  ,jj+1,jk) - tb(ji,jj,jk) )
-               zsv(ji,jj,jk) = zabe2 * ( sb(ji  ,jj+1,jk) - sb(ji,jj,jk) )
-            END DO  
-         END DO  
-         IF( ln_zps ) THEN      ! set gradient at partial step level
+
+      !                                                          ! =========== !
+      DO jn = 1, kjpt                                            ! tracer loop !
+         !                                                       ! =========== !    
+         DO jk = 1, jpkm1                                            ! slab loop
+            !                                           
+            ! 1. First derivative (gradient)
+            ! -------------------
             DO jj = 1, jpjm1
                DO ji = 1, fs_jpim1   ! vector opt.
-                  ! last level
-                  iku = MIN ( mbathy(ji,jj), mbathy(ji+1,jj  ) ) - 1
-                  ikv = MIN ( mbathy(ji,jj), mbathy(ji  ,jj+1) ) - 1
-                  IF( iku == jk ) THEN
-                     zabe1 = fsahtu(ji,jj,iku) * umask(ji,jj,iku) * ze1ur(ji,jj) * fse3u(ji,jj,iku)
-                     ztu(ji,jj,jk) = zabe1 * gtu(ji,jj)
-                     zsu(ji,jj,jk) = zabe1 * gsu(ji,jj)
-                  ENDIF
-                  IF( ikv == jk ) THEN
-                     zabe2 = fsahtv(ji,jj,ikv) * vmask(ji,jj,ikv) * ze2vr(ji,jj) * fse3v(ji,jj,ikv)
-                     ztv(ji,jj,jk) = zabe2 * gtv(ji,jj)
-                     zsv(ji,jj,jk) = zabe2 * gsv(ji,jj)
-                  ENDIF
+                  zabe1 = fsahtu(ji,jj,jk) * umask(ji,jj,jk) * e1ur(ji,jj) * fse3u(ji,jj,jk)
+                  zabe2 = fsahtv(ji,jj,jk) * vmask(ji,jj,jk) * e2vr(ji,jj) * fse3v(ji,jj,jk)
+                  ztu(ji,jj,jk) = zabe1 * ( ptb(ji+1,jj  ,jk,jn) - ptb(ji,jj,jk,jn) )
+                  ztv(ji,jj,jk) = zabe2 * ( ptb(ji  ,jj+1,jk,jn) - ptb(ji,jj,jk,jn) )
                END DO
             END DO
-         ENDIF
+            IF( ln_zps ) THEN      ! set gradient at partial step level
+               DO jj = 1, jpjm1
+                  DO ji = 1, fs_jpim1   ! vector opt.
+                     ! last level
+                     iku = mbku(ji,jj)
+                     ikv = mbkv(ji,jj)
+                     IF( iku == jk ) THEN
+                        zabe1 = fsahtu(ji,jj,iku) * umask(ji,jj,iku) * e1ur(ji,jj) * fse3u(ji,jj,iku)
+                        ztu(ji,jj,jk) = zabe1 * pgu(ji,jj,jn)
+                     ENDIF
+                     IF( ikv == jk ) THEN
+                        zabe2 = fsahtv(ji,jj,ikv) * vmask(ji,jj,ikv) * e2vr(ji,jj) * fse3v(ji,jj,ikv)
+                        ztv(ji,jj,jk) = zabe2 * pgv(ji,jj,jn)
+                     ENDIF
+                  END DO
+               END DO
+            ENDIF
          
          
-         ! 2. Second derivative (divergence)
-         ! --------------------
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1   ! vector opt.
-#if defined key_zco
-               zbtr = zbtr2(ji,jj)
-#else
-               zbtr = zbtr2(ji,jj) / fse3t(ji,jj,jk)
-#endif
-               ! horizontal diffusive trends
-               zta = zbtr * (  ztu(ji,jj,jk) - ztu(ji-1,jj,jk)   &
-                  &          + ztv(ji,jj,jk) - ztv(ji,jj-1,jk)  )
-               zsa = zbtr * (  zsu(ji,jj,jk) - zsu(ji-1,jj,jk)   &
-                  &          + zsv(ji,jj,jk) - zsv(ji,jj-1,jk)  )
-               ! add it to the general tracer trends
-               ta(ji,jj,jk) = ta(ji,jj,jk) + zta
-               sa(ji,jj,jk) = sa(ji,jj,jk) + zsa
-            END DO  
-         END DO  
-         !                                               ! =============
-      END DO                                             !  End of slab  
-      !                                                  ! =============
-
-      ! "zonal" mean lateral diffusive heat and salt transport 
-      IF( ln_diaptr .AND. ( MOD( kt, nf_ptr ) == 0 ) ) THEN
-         IF( lk_zco ) THEN   ! z-coordinate - full step (1D arrays)
-            DO jk = 1, jpkm1
-               DO jj = 2, jpjm1
-                  DO ji = fs_2, fs_jpim1   ! vector opt.
-                    ztv(ji,jj,jk) = ztv(ji,jj,jk) * fse3v(ji,jj,jk)
-                    zsv(ji,jj,jk) = zsv(ji,jj,jk) * fse3v(ji,jj,jk)
-                  END DO
+            ! 2. Second derivative (divergence) added to the general tracer trends
+            ! ---------------------------------------------------------------------
+            DO jj = 2, jpjm1
+               DO ji = fs_2, fs_jpim1   ! vector opt.
+                  zbtr = 1.0 / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+                  ! horizontal diffusive trends added to the general tracer trends
+                  pta(ji,jj,jk,jn) = pta(ji,jj,jk,jn) + zbtr * (  ztu(ji,jj,jk) - ztu(ji-1,jj,jk)   &
+                     &                                          + ztv(ji,jj,jk) - ztv(ji,jj-1,jk)  )
                END DO
             END DO
+            !
+         END DO                                             !  End of slab  
+         !
+         ! "Poleward" diffusive heat or salt transports
+         IF( cdtype == 'TRA' .AND. ln_diaptr .AND. ( MOD( kt, nn_fptr ) == 0 ) ) THEN
+            IF( jn  == jp_tem)   htr_ldf(:) = ptr_vj( ztv(:,:,:) )
+            IF( jn  == jp_sal)   str_ldf(:) = ptr_vj( ztv(:,:,:) )
          ENDIF
-         pht_ldf(:) = ptr_vj( ztv(:,:,:) )
-         pst_ldf(:) = ptr_vj( zsv(:,:,:) )
-      ENDIF
-
+         !                                                  ! ==================
+      END DO                                                ! end of tracer loop
+      !                                                     ! ==================
    END SUBROUTINE tra_ldf_lap
 
Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRA/tranpc.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRA/tranpc.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRA/tranpc.F90	(revision 2528)
@@ -8,4 +8,5 @@
    !!   NEMO     1.0  ! 2002-06  (G. Madec)  free form F90
    !!            3.0  ! 2008-06  (G. Madec)  applied on ta, sa and called before tranxt in step.F90
+   !!            3.3  ! 2010-05  (C. Ethe, G. Madec)  merge TRC-TRA
    !!----------------------------------------------------------------------
 
@@ -16,6 +17,6 @@
    USE dom_oce         ! ocean space and time domain
    USE zdf_oce         ! ocean vertical physics
-   USE trdmod          ! ocean active tracer trends
-   USE trdmod_oce      ! ocean variables trends
+   USE trdmod_oce      ! ocean active tracer trends
+   USE trdtra      ! ocean active tracer trends
    USE eosbn2          ! equation of state (eos routine) 
    USE lbclnk          ! lateral boundary conditions (or mpp link)
@@ -30,9 +31,8 @@
 #  include "domzgr_substitute.h90"
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
-   !!----------------------------------------------------------------------
-
+   !! Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
 CONTAINS
 
@@ -55,7 +55,4 @@
       !! References : Madec, et al., 1991, JPO, 21, 9, 1349-1371.
       !!----------------------------------------------------------------------
-      USE oce, ONLY :    ztrdt => ua   ! use ua as 3D workspace   
-      USE oce, ONLY :    ztrds => va   ! use va as 3D workspace   
-      !! 
       INTEGER, INTENT(in) ::   kt   ! ocean time-step index
       !!
@@ -68,4 +65,5 @@
       REAL(wp), DIMENSION(jpi,jpk)     ::   zwx, zwy, zwz   ! 2D arrays
       REAL(wp), DIMENSION(jpi,jpj,jpk) ::   zrhop           ! 3D arrays
+      REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  ztrdt, ztrds
       !!----------------------------------------------------------------------
 
@@ -75,10 +73,9 @@
          inpci = 0
 
-         CALL eos( ta, sa, rhd, zrhop )         ! Potential density
-
-
-         IF( l_trdtra )   THEN                  ! Save ta and sa trends
-            ztrdt(:,:,:) = ta(:,:,:) 
-            ztrds(:,:,:) = sa(:,:,:) 
+         CALL eos( tsa, rhd, zrhop )         ! Potential density
+
+         IF( l_trdtra )   THEN                    !* Save ta and sa trends
+            ALLOCATE( ztrdt(jpi,jpj,jpk) )  ;    ztrdt(:,:,:) = tsa(:,:,:,jp_tem) 
+            ALLOCATE( ztrds(jpi,jpj,jpk) )  ;    ztrds(:,:,:) = tsa(:,:,:,jp_sal)
          ENDIF
 
@@ -133,5 +130,5 @@
                   IF( zwy(ji,1) /= 0.e0 ) THEN
                      !
-                     ikbot = mbathy(ji,jj)      ! ikbot: ocean bottom level
+                     ikbot = mbkt(ji,jj)        ! ikbot: ocean bottom T-level
                      !
                      DO jiter = 1, jpk          ! vertical iteration
@@ -142,5 +139,5 @@
 220                     CONTINUE
                         ik = ik + 1
-                        IF( ik >= ikbot-1 ) GO TO 200
+                        IF( ik >= ikbot ) GO TO 200
                         zwx(ji,ik) = zrhop(ji,jj,ik) - zrhop(ji,jj,ik+1)
                         IF( zwx(ji,ik) <= 0.e0 ) GO TO 220
@@ -151,6 +148,6 @@
                         !
                         ze3tot= fse3t(ji,jj,ikup)
-                        zta   = ta   (ji,jj,ikup)
-                        zsa   = sa   (ji,jj,ikup)
+                        zta   = tsa  (ji,jj,ikup,jp_tem)
+                        zsa   = tsa  (ji,jj,ikup,jp_sal)
                         zraua = zrhop(ji,jj,ikup)
                         !
@@ -162,6 +159,6 @@
                            ze3dwn =  fse3t(ji,jj,jkdown)
                            ze3tot =  ze3tot + ze3dwn
-                           zta   = ( zta*(ze3tot-ze3dwn) + ta(ji,jj,jkdown)*ze3dwn )/ze3tot
-                           zsa   = ( zsa*(ze3tot-ze3dwn) + sa(ji,jj,jkdown)*ze3dwn )/ze3tot
+                           zta   = ( zta*(ze3tot-ze3dwn) + tsa(ji,jj,jkdown,jp_tem)*ze3dwn )/ze3tot
+                           zsa   = ( zsa*(ze3tot-ze3dwn) + tsa(ji,jj,jkdown,jp_sal)*ze3dwn )/ze3tot
                            zraua = ( zraua*(ze3tot-ze3dwn) + zrhop(ji,jj,jkdown)*ze3dwn )/ze3tot
                            inpci = inpci+1
@@ -171,12 +168,12 @@
                         !
                         DO jkp = ikup, ikdown-1
-                           ta(ji,jj,jkp) = zta
-                           sa(ji,jj,jkp) = zsa
-                           zrhop(ji,jj,jkp) = zraua
+                           tsa  (ji,jj,jkp,jp_tem) = zta
+                           tsa  (ji,jj,jkp,jp_sal) = zsa
+                           zrhop(ji,jj,jkp       ) = zraua
                         END DO
                         IF (ikdown == ikbot-1 .AND. zraua >= zrhop(ji,jj,ikdown) ) THEN
-                           ta(ji,jj,ikdown) = zta
-                           sa(ji,jj,ikdown) = zsa
-                           zrhop(ji,jj,ikdown) = zraua
+                           tsa  (ji,jj,jkp,jp_tem) = zta
+                           tsa  (ji,jj,jkp,jp_sal) = zsa
+                           zrhop(ji,jj,ikdown    ) = zraua
                         ENDIF
                      END DO
@@ -191,13 +188,15 @@
          ! 
          IF( l_trdtra )   THEN         ! save the Non penetrative mixing trends for diagnostic
-            ztrdt(:,:,:) = ta(:,:,:) - ztrdt(:,:,:)
-            ztrds(:,:,:) = sa(:,:,:) - ztrds(:,:,:)
-            CALL trd_mod(ztrdt, ztrds, jptra_trd_npc, 'TRA', kt)
+            ztrdt(:,:,:) = tsa(:,:,:,jp_tem) - ztrdt(:,:,:)
+            ztrds(:,:,:) = tsa(:,:,:,jp_sal) - ztrds(:,:,:)
+            CALL trd_tra( kt, 'TRA', jp_tem, jptra_trd_npc, ztrdt )
+            CALL trd_tra( kt, 'TRA', jp_sal, jptra_trd_npc, ztrds )
+            DEALLOCATE( ztrdt )      ;     DEALLOCATE( ztrds ) 
          ENDIF
       
          ! Lateral boundary conditions on ( ta, sa )   ( Unchanged sign)
          ! ------------------------------============
-         CALL lbc_lnk( ta, 'T', 1. )
-         CALL lbc_lnk( sa, 'T', 1. )
+         CALL lbc_lnk( tsa(:,:,:,jp_tem), 'T', 1. )
+         CALL lbc_lnk( tsa(:,:,:,jp_sal), 'T', 1. )
       
 
